/**
 * This file was automatically generated by @oraichain/ts-codegen@0.35.9.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run the @oraichain/ts-codegen generate command to regenerate this file.
 */
import { CosmWasmClient, SigningCosmWasmClient, ExecuteResult } from "@cosmjs/cosmwasm-stargate";
import { Coin, StdFee } from "@cosmjs/amino";
import { Addr, Uint128, Binary, Decimal, Asset, RewardMsg } from "./types";
import { ConfigResponse, ArrayOfQueryPoolInfoResponse, PoolInfoResponse, LockInfosResponse, RewardInfoResponse, ArrayOfRewardInfoResponse, RewardsPerSecResponse, StakedBalanceAtHeightResponse, TotalStakedAtHeightResponse, ArrayOfUnbondOptionResponse } from "./Cw20Staking.types";
export interface Cw20StakingReadOnlyInterface {
    contractAddress: string;
    config: () => Promise<ConfigResponse>;
    poolInfo: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<PoolInfoResponse>;
    rewardsPerSec: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<RewardsPerSecResponse>;
    rewardInfo: ({ stakerAddr, stakingToken }: {
        stakerAddr: Addr;
        stakingToken?: Addr;
    }) => Promise<RewardInfoResponse>;
    rewardInfos: ({ limit, order, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakingToken: Addr;
        startAfter?: Addr;
    }) => Promise<ArrayOfRewardInfoResponse>;
    getPoolsInformation: () => Promise<ArrayOfQueryPoolInfoResponse>;
    lockInfos: ({ limit, order, stakerAddr, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakerAddr: Addr;
        stakingToken: Addr;
        startAfter?: number;
    }) => Promise<LockInfosResponse>;
    stakedBalanceAtHeight: ({ address, assetKey, height }: {
        address: string;
        assetKey: Addr;
        height?: number;
    }) => Promise<StakedBalanceAtHeightResponse>;
    totalStakedAtHeight: ({ assetKey, height }: {
        assetKey: Addr;
        height?: number;
    }) => Promise<TotalStakedAtHeightResponse>;
    unbondFee: ({ period, stakingToken }: {
        period: number;
        stakingToken: Addr;
    }) => Promise<Decimal>;
    unbondOptions: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<ArrayOfUnbondOptionResponse>;
}
export declare class Cw20StakingQueryClient implements Cw20StakingReadOnlyInterface {
    client: CosmWasmClient;
    contractAddress: string;
    constructor(client: CosmWasmClient, contractAddress: string);
    config: () => Promise<ConfigResponse>;
    poolInfo: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<PoolInfoResponse>;
    rewardsPerSec: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<RewardsPerSecResponse>;
    rewardInfo: ({ stakerAddr, stakingToken }: {
        stakerAddr: Addr;
        stakingToken?: Addr;
    }) => Promise<RewardInfoResponse>;
    rewardInfos: ({ limit, order, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakingToken: Addr;
        startAfter?: Addr;
    }) => Promise<ArrayOfRewardInfoResponse>;
    getPoolsInformation: () => Promise<ArrayOfQueryPoolInfoResponse>;
    lockInfos: ({ limit, order, stakerAddr, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakerAddr: Addr;
        stakingToken: Addr;
        startAfter?: number;
    }) => Promise<LockInfosResponse>;
    stakedBalanceAtHeight: ({ address, assetKey, height }: {
        address: string;
        assetKey: Addr;
        height?: number;
    }) => Promise<StakedBalanceAtHeightResponse>;
    totalStakedAtHeight: ({ assetKey, height }: {
        assetKey: Addr;
        height?: number;
    }) => Promise<TotalStakedAtHeightResponse>;
    unbondFee: ({ period, stakingToken }: {
        period: number;
        stakingToken: Addr;
    }) => Promise<Decimal>;
    unbondOptions: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<ArrayOfUnbondOptionResponse>;
}
export interface Cw20StakingInterface extends Cw20StakingReadOnlyInterface {
    contractAddress: string;
    sender: string;
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ owner, rewarder, withdrawFeeReceiver }: {
        owner?: Addr;
        rewarder?: Addr;
        withdrawFeeReceiver?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateUnbondingPeriod: ({ stakingToken, unbondingPeriod }: {
        stakingToken: Addr;
        unbondingPeriod: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    registerAsset: ({ stakingToken, unbondingPeriod }: {
        stakingToken: Addr;
        unbondingPeriod?: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateRewardsPerSec: ({ assets, stakingToken }: {
        assets: Asset[];
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    depositReward: ({ rewards }: {
        rewards: RewardMsg[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unbond: ({ amount, stakingToken, unbondPeriod }: {
        amount: Uint128;
        stakingToken: Addr;
        unbondPeriod?: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdraw: ({ stakingToken }: {
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawOthers: ({ stakerAddrs, stakingToken }: {
        stakerAddrs: Addr[];
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    restake: ({ stakingToken }: {
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateUnbondOption: ({ fee, period, stakingToken }: {
        fee: Decimal;
        period: number;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    removeUnbondOption: ({ period, stakingToken }: {
        period: number;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
export declare class Cw20StakingClient extends Cw20StakingQueryClient implements Cw20StakingInterface {
    client: SigningCosmWasmClient;
    sender: string;
    contractAddress: string;
    constructor(client: SigningCosmWasmClient, sender: string, contractAddress: string);
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ owner, rewarder, withdrawFeeReceiver }: {
        owner?: Addr;
        rewarder?: Addr;
        withdrawFeeReceiver?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateUnbondingPeriod: ({ stakingToken, unbondingPeriod }: {
        stakingToken: Addr;
        unbondingPeriod: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    registerAsset: ({ stakingToken, unbondingPeriod }: {
        stakingToken: Addr;
        unbondingPeriod?: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateRewardsPerSec: ({ assets, stakingToken }: {
        assets: Asset[];
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    depositReward: ({ rewards }: {
        rewards: RewardMsg[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unbond: ({ amount, stakingToken, unbondPeriod }: {
        amount: Uint128;
        stakingToken: Addr;
        unbondPeriod?: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdraw: ({ stakingToken }: {
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawOthers: ({ stakerAddrs, stakingToken }: {
        stakerAddrs: Addr[];
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    restake: ({ stakingToken }: {
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateUnbondOption: ({ fee, period, stakingToken }: {
        fee: Decimal;
        period: number;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    removeUnbondOption: ({ period, stakingToken }: {
        period: number;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
