"use strict";
/**
 * This file was automatically generated by @oraichain/ts-codegen@0.35.9.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run the @oraichain/ts-codegen generate command to regenerate this file.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Cw20StakingClient = exports.Cw20StakingQueryClient = void 0;
class Cw20StakingQueryClient {
    constructor(client, contractAddress) {
        this.config = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                config: {}
            });
        };
        this.poolInfo = async ({ stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                pool_info: {
                    staking_token: stakingToken
                }
            });
        };
        this.rewardsPerSec = async ({ stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                rewards_per_sec: {
                    staking_token: stakingToken
                }
            });
        };
        this.rewardInfo = async ({ stakerAddr, stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                reward_info: {
                    staker_addr: stakerAddr,
                    staking_token: stakingToken
                }
            });
        };
        this.rewardInfos = async ({ limit, order, stakingToken, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                reward_infos: {
                    limit,
                    order,
                    staking_token: stakingToken,
                    start_after: startAfter
                }
            });
        };
        this.getPoolsInformation = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                get_pools_information: {}
            });
        };
        this.lockInfos = async ({ limit, order, stakerAddr, stakingToken, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                lock_infos: {
                    limit,
                    order,
                    staker_addr: stakerAddr,
                    staking_token: stakingToken,
                    start_after: startAfter
                }
            });
        };
        this.stakedBalanceAtHeight = async ({ address, assetKey, height }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                staked_balance_at_height: {
                    address,
                    asset_key: assetKey,
                    height
                }
            });
        };
        this.totalStakedAtHeight = async ({ assetKey, height }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                total_staked_at_height: {
                    asset_key: assetKey,
                    height
                }
            });
        };
        this.unbondFee = async ({ period, stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                unbond_fee: {
                    period,
                    staking_token: stakingToken
                }
            });
        };
        this.unbondOptions = async ({ stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                unbond_options: {
                    staking_token: stakingToken
                }
            });
        };
        this.client = client;
        this.contractAddress = contractAddress;
        this.config = this.config.bind(this);
        this.poolInfo = this.poolInfo.bind(this);
        this.rewardsPerSec = this.rewardsPerSec.bind(this);
        this.rewardInfo = this.rewardInfo.bind(this);
        this.rewardInfos = this.rewardInfos.bind(this);
        this.getPoolsInformation = this.getPoolsInformation.bind(this);
        this.lockInfos = this.lockInfos.bind(this);
        this.stakedBalanceAtHeight = this.stakedBalanceAtHeight.bind(this);
        this.totalStakedAtHeight = this.totalStakedAtHeight.bind(this);
        this.unbondFee = this.unbondFee.bind(this);
        this.unbondOptions = this.unbondOptions.bind(this);
    }
}
exports.Cw20StakingQueryClient = Cw20StakingQueryClient;
class Cw20StakingClient extends Cw20StakingQueryClient {
    constructor(client, sender, contractAddress) {
        super(client, contractAddress);
        this.receive = async ({ amount, msg, sender }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                receive: {
                    amount,
                    msg,
                    sender
                }
            }, _fee, _memo, _funds);
        };
        this.updateConfig = async ({ owner, rewarder, withdrawFeeReceiver }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_config: {
                    owner,
                    rewarder,
                    withdraw_fee_receiver: withdrawFeeReceiver
                }
            }, _fee, _memo, _funds);
        };
        this.updateUnbondingPeriod = async ({ stakingToken, unbondingPeriod }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_unbonding_period: {
                    staking_token: stakingToken,
                    unbonding_period: unbondingPeriod
                }
            }, _fee, _memo, _funds);
        };
        this.registerAsset = async ({ stakingToken, unbondingPeriod }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                register_asset: {
                    staking_token: stakingToken,
                    unbonding_period: unbondingPeriod
                }
            }, _fee, _memo, _funds);
        };
        this.updateRewardsPerSec = async ({ assets, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_rewards_per_sec: {
                    assets,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.depositReward = async ({ rewards }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                deposit_reward: {
                    rewards
                }
            }, _fee, _memo, _funds);
        };
        this.unbond = async ({ amount, stakingToken, unbondPeriod }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                unbond: {
                    amount,
                    staking_token: stakingToken,
                    unbond_period: unbondPeriod
                }
            }, _fee, _memo, _funds);
        };
        this.withdraw = async ({ stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                withdraw: {
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.withdrawOthers = async ({ stakerAddrs, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                withdraw_others: {
                    staker_addrs: stakerAddrs,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.restake = async ({ stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                restake: {
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.updateUnbondOption = async ({ fee, period, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_unbond_option: {
                    fee,
                    period,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.removeUnbondOption = async ({ period, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                remove_unbond_option: {
                    period,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.client = client;
        this.sender = sender;
        this.contractAddress = contractAddress;
        this.receive = this.receive.bind(this);
        this.updateConfig = this.updateConfig.bind(this);
        this.updateUnbondingPeriod = this.updateUnbondingPeriod.bind(this);
        this.registerAsset = this.registerAsset.bind(this);
        this.updateRewardsPerSec = this.updateRewardsPerSec.bind(this);
        this.depositReward = this.depositReward.bind(this);
        this.unbond = this.unbond.bind(this);
        this.withdraw = this.withdraw.bind(this);
        this.withdrawOthers = this.withdrawOthers.bind(this);
        this.restake = this.restake.bind(this);
        this.updateUnbondOption = this.updateUnbondOption.bind(this);
        this.removeUnbondOption = this.removeUnbondOption.bind(this);
    }
}
exports.Cw20StakingClient = Cw20StakingClient;
//# sourceMappingURL=Cw20Staking.client.js.map