/**
* This file was automatically generated by @oraichain/ts-codegen@0.35.9.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run the @oraichain/ts-codegen generate command to regenerate this file.
*/
import { CosmWasmClient, SigningCosmWasmClient, ExecuteResult } from "@cosmjs/cosmwasm-stargate";
import { Coin, StdFee } from "@cosmjs/amino";
import { Uint128, Binary, Addr, AssetInfo, Decimal, Asset } from "./types";
import { OrderDirection, OrderFilter, ContractInfoResponse, LastOrderIdResponse, OrderResponse, OrderBookResponse, OrderBooksResponse, OrdersResponse, SimulateMarketOrderResponse, TickResponse, TicksResponse } from "./OraiswapOrderbook.types";
export interface OraiswapOrderbookReadOnlyInterface {
    contractAddress: string;
    contractInfo: () => Promise<ContractInfoResponse>;
    orderBook: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }) => Promise<OrderBookResponse>;
    orderBooks: ({ limit, orderBy, startAfter }: {
        limit?: number;
        orderBy?: number;
        startAfter?: number[];
    }) => Promise<OrderBooksResponse>;
    order: ({ assetInfos, orderId }: {
        assetInfos: AssetInfo[];
        orderId: number;
    }) => Promise<OrderResponse>;
    orders: ({ assetInfos, direction, filter, limit, orderBy, startAfter }: {
        assetInfos: AssetInfo[];
        direction?: OrderDirection;
        filter: OrderFilter;
        limit?: number;
        orderBy?: number;
        startAfter?: number;
    }) => Promise<OrdersResponse>;
    tick: ({ assetInfos, direction, price }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        price: Decimal;
    }) => Promise<TickResponse>;
    ticks: ({ assetInfos, direction, end, limit, orderBy, startAfter }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        end?: Decimal;
        limit?: number;
        orderBy?: number;
        startAfter?: Decimal;
    }) => Promise<TicksResponse>;
    lastOrderId: () => Promise<LastOrderIdResponse>;
    midPrice: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }) => Promise<Decimal>;
    simulateMarketOrder: ({ assetInfos, direction, offerAmount, slippage }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        offerAmount: Uint128;
        slippage?: Decimal;
    }) => Promise<SimulateMarketOrderResponse>;
}
export declare class OraiswapOrderbookQueryClient implements OraiswapOrderbookReadOnlyInterface {
    client: CosmWasmClient;
    contractAddress: string;
    constructor(client: CosmWasmClient, contractAddress: string);
    contractInfo: () => Promise<ContractInfoResponse>;
    orderBook: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }) => Promise<OrderBookResponse>;
    orderBooks: ({ limit, orderBy, startAfter }: {
        limit?: number;
        orderBy?: number;
        startAfter?: number[];
    }) => Promise<OrderBooksResponse>;
    order: ({ assetInfos, orderId }: {
        assetInfos: AssetInfo[];
        orderId: number;
    }) => Promise<OrderResponse>;
    orders: ({ assetInfos, direction, filter, limit, orderBy, startAfter }: {
        assetInfos: AssetInfo[];
        direction?: OrderDirection;
        filter: OrderFilter;
        limit?: number;
        orderBy?: number;
        startAfter?: number;
    }) => Promise<OrdersResponse>;
    tick: ({ assetInfos, direction, price }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        price: Decimal;
    }) => Promise<TickResponse>;
    ticks: ({ assetInfos, direction, end, limit, orderBy, startAfter }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        end?: Decimal;
        limit?: number;
        orderBy?: number;
        startAfter?: Decimal;
    }) => Promise<TicksResponse>;
    lastOrderId: () => Promise<LastOrderIdResponse>;
    midPrice: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }) => Promise<Decimal>;
    simulateMarketOrder: ({ assetInfos, direction, offerAmount, slippage }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        offerAmount: Uint128;
        slippage?: Decimal;
    }) => Promise<SimulateMarketOrderResponse>;
}
export interface OraiswapOrderbookInterface extends OraiswapOrderbookReadOnlyInterface {
    contractAddress: string;
    sender: string;
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    pause: (_fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unpause: (_fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateAdmin: ({ admin }: {
        admin: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ commissionRate, rewardAddress }: {
        commissionRate?: string;
        rewardAddress?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateOperator: ({ operator }: {
        operator?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    createOrderBookPair: ({ baseCoinInfo, minQuoteCoinAmount, quoteCoinInfo, refundThreshold, spread }: {
        baseCoinInfo: AssetInfo;
        minQuoteCoinAmount: Uint128;
        quoteCoinInfo: AssetInfo;
        refundThreshold?: Uint128;
        spread?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateOrderbookPair: ({ assetInfos, minQuoteCoinAmount, refundThreshold, spread }: {
        assetInfos: AssetInfo[];
        minQuoteCoinAmount?: Uint128;
        refundThreshold?: Uint128;
        spread?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    submitOrder: ({ assets, direction }: {
        assets: Asset[];
        direction: OrderDirection;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    submitMarketOrder: ({ assetInfos, direction, slippage }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        slippage?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    cancelOrder: ({ assetInfos, orderId }: {
        assetInfos: AssetInfo[];
        orderId: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    removeOrderBookPair: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawToken: ({ asset }: {
        asset: Asset;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
export declare class OraiswapOrderbookClient extends OraiswapOrderbookQueryClient implements OraiswapOrderbookInterface {
    client: SigningCosmWasmClient;
    sender: string;
    contractAddress: string;
    constructor(client: SigningCosmWasmClient, sender: string, contractAddress: string);
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    pause: (_fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unpause: (_fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateAdmin: ({ admin }: {
        admin: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ commissionRate, rewardAddress }: {
        commissionRate?: string;
        rewardAddress?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateOperator: ({ operator }: {
        operator?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    createOrderBookPair: ({ baseCoinInfo, minQuoteCoinAmount, quoteCoinInfo, refundThreshold, spread }: {
        baseCoinInfo: AssetInfo;
        minQuoteCoinAmount: Uint128;
        quoteCoinInfo: AssetInfo;
        refundThreshold?: Uint128;
        spread?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateOrderbookPair: ({ assetInfos, minQuoteCoinAmount, refundThreshold, spread }: {
        assetInfos: AssetInfo[];
        minQuoteCoinAmount?: Uint128;
        refundThreshold?: Uint128;
        spread?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    submitOrder: ({ assets, direction }: {
        assets: Asset[];
        direction: OrderDirection;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    submitMarketOrder: ({ assetInfos, direction, slippage }: {
        assetInfos: AssetInfo[];
        direction: OrderDirection;
        slippage?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    cancelOrder: ({ assetInfos, orderId }: {
        assetInfos: AssetInfo[];
        orderId: number;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    removeOrderBookPair: ({ assetInfos }: {
        assetInfos: AssetInfo[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawToken: ({ asset }: {
        asset: Asset;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
