"use strict";
/**
* This file was automatically generated by @oraichain/ts-codegen@0.35.9.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run the @oraichain/ts-codegen generate command to regenerate this file.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.OraiswapOrderbookClient = exports.OraiswapOrderbookQueryClient = void 0;
class OraiswapOrderbookQueryClient {
    constructor(client, contractAddress) {
        this.contractInfo = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                contract_info: {}
            });
        };
        this.orderBook = async ({ assetInfos }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                order_book: {
                    asset_infos: assetInfos
                }
            });
        };
        this.orderBooks = async ({ limit, orderBy, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                order_books: {
                    limit,
                    order_by: orderBy,
                    start_after: startAfter
                }
            });
        };
        this.order = async ({ assetInfos, orderId }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                order: {
                    asset_infos: assetInfos,
                    order_id: orderId
                }
            });
        };
        this.orders = async ({ assetInfos, direction, filter, limit, orderBy, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                orders: {
                    asset_infos: assetInfos,
                    direction,
                    filter,
                    limit,
                    order_by: orderBy,
                    start_after: startAfter
                }
            });
        };
        this.tick = async ({ assetInfos, direction, price }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                tick: {
                    asset_infos: assetInfos,
                    direction,
                    price
                }
            });
        };
        this.ticks = async ({ assetInfos, direction, end, limit, orderBy, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                ticks: {
                    asset_infos: assetInfos,
                    direction,
                    end,
                    limit,
                    order_by: orderBy,
                    start_after: startAfter
                }
            });
        };
        this.lastOrderId = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                last_order_id: {}
            });
        };
        this.midPrice = async ({ assetInfos }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                mid_price: {
                    asset_infos: assetInfos
                }
            });
        };
        this.simulateMarketOrder = async ({ assetInfos, direction, offerAmount, slippage }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                simulate_market_order: {
                    asset_infos: assetInfos,
                    direction,
                    offer_amount: offerAmount,
                    slippage
                }
            });
        };
        this.client = client;
        this.contractAddress = contractAddress;
        this.contractInfo = this.contractInfo.bind(this);
        this.orderBook = this.orderBook.bind(this);
        this.orderBooks = this.orderBooks.bind(this);
        this.order = this.order.bind(this);
        this.orders = this.orders.bind(this);
        this.tick = this.tick.bind(this);
        this.ticks = this.ticks.bind(this);
        this.lastOrderId = this.lastOrderId.bind(this);
        this.midPrice = this.midPrice.bind(this);
        this.simulateMarketOrder = this.simulateMarketOrder.bind(this);
    }
}
exports.OraiswapOrderbookQueryClient = OraiswapOrderbookQueryClient;
class OraiswapOrderbookClient extends OraiswapOrderbookQueryClient {
    constructor(client, sender, contractAddress) {
        super(client, contractAddress);
        this.receive = async ({ amount, msg, sender }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                receive: {
                    amount,
                    msg,
                    sender
                }
            }, _fee, _memo, _funds);
        };
        this.pause = async (_fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                pause: {}
            }, _fee, _memo, _funds);
        };
        this.unpause = async (_fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                unpause: {}
            }, _fee, _memo, _funds);
        };
        this.updateAdmin = async ({ admin }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_admin: {
                    admin
                }
            }, _fee, _memo, _funds);
        };
        this.updateConfig = async ({ commissionRate, rewardAddress }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_config: {
                    commission_rate: commissionRate,
                    reward_address: rewardAddress
                }
            }, _fee, _memo, _funds);
        };
        this.updateOperator = async ({ operator }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_operator: {
                    operator
                }
            }, _fee, _memo, _funds);
        };
        this.createOrderBookPair = async ({ baseCoinInfo, minQuoteCoinAmount, quoteCoinInfo, refundThreshold, spread }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                create_order_book_pair: {
                    base_coin_info: baseCoinInfo,
                    min_quote_coin_amount: minQuoteCoinAmount,
                    quote_coin_info: quoteCoinInfo,
                    refund_threshold: refundThreshold,
                    spread
                }
            }, _fee, _memo, _funds);
        };
        this.updateOrderbookPair = async ({ assetInfos, minQuoteCoinAmount, refundThreshold, spread }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_orderbook_pair: {
                    asset_infos: assetInfos,
                    min_quote_coin_amount: minQuoteCoinAmount,
                    refund_threshold: refundThreshold,
                    spread
                }
            }, _fee, _memo, _funds);
        };
        this.submitOrder = async ({ assets, direction }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                submit_order: {
                    assets,
                    direction
                }
            }, _fee, _memo, _funds);
        };
        this.submitMarketOrder = async ({ assetInfos, direction, slippage }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                submit_market_order: {
                    asset_infos: assetInfos,
                    direction,
                    slippage
                }
            }, _fee, _memo, _funds);
        };
        this.cancelOrder = async ({ assetInfos, orderId }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                cancel_order: {
                    asset_infos: assetInfos,
                    order_id: orderId
                }
            }, _fee, _memo, _funds);
        };
        this.removeOrderBookPair = async ({ assetInfos }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                remove_order_book_pair: {
                    asset_infos: assetInfos
                }
            }, _fee, _memo, _funds);
        };
        this.withdrawToken = async ({ asset }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                withdraw_token: {
                    asset
                }
            }, _fee, _memo, _funds);
        };
        this.client = client;
        this.sender = sender;
        this.contractAddress = contractAddress;
        this.receive = this.receive.bind(this);
        this.pause = this.pause.bind(this);
        this.unpause = this.unpause.bind(this);
        this.updateAdmin = this.updateAdmin.bind(this);
        this.updateConfig = this.updateConfig.bind(this);
        this.updateOperator = this.updateOperator.bind(this);
        this.createOrderBookPair = this.createOrderBookPair.bind(this);
        this.updateOrderbookPair = this.updateOrderbookPair.bind(this);
        this.submitOrder = this.submitOrder.bind(this);
        this.submitMarketOrder = this.submitMarketOrder.bind(this);
        this.cancelOrder = this.cancelOrder.bind(this);
        this.removeOrderBookPair = this.removeOrderBookPair.bind(this);
        this.withdrawToken = this.withdrawToken.bind(this);
    }
}
exports.OraiswapOrderbookClient = OraiswapOrderbookClient;
//# sourceMappingURL=OraiswapOrderbook.client.js.map