/**
* This file was automatically generated by @oraichain/ts-codegen@0.35.9.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run the @oraichain/ts-codegen generate command to regenerate this file.
*/
import { CosmWasmClient, SigningCosmWasmClient, ExecuteResult } from "@cosmjs/cosmwasm-stargate";
import { Coin, StdFee } from "@cosmjs/amino";
import { Addr, Uint128, Binary, Decimal, Asset, RewardMsg } from "./types";
import { OldStoreType, ConfigResponse, ArrayOfQueryPoolInfoResponse, PoolInfoResponse, RewardInfoResponse, ArrayOfRewardInfoResponse, RewardsPerSecResponse } from "./OraiswapStaking.types";
export interface OraiswapStakingReadOnlyInterface {
    contractAddress: string;
    config: () => Promise<ConfigResponse>;
    poolInfo: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<PoolInfoResponse>;
    rewardsPerSec: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<RewardsPerSecResponse>;
    rewardInfo: ({ stakerAddr, stakingToken }: {
        stakerAddr: Addr;
        stakingToken?: Addr;
    }) => Promise<RewardInfoResponse>;
    rewardInfos: ({ limit, order, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakingToken: Addr;
        startAfter?: Addr;
    }) => Promise<ArrayOfRewardInfoResponse>;
    getPoolsInformation: () => Promise<ArrayOfQueryPoolInfoResponse>;
    queryOldStore: ({ storeType }: {
        storeType: OldStoreType;
    }) => Promise<Binary>;
}
export declare class OraiswapStakingQueryClient implements OraiswapStakingReadOnlyInterface {
    client: CosmWasmClient;
    contractAddress: string;
    constructor(client: CosmWasmClient, contractAddress: string);
    config: () => Promise<ConfigResponse>;
    poolInfo: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<PoolInfoResponse>;
    rewardsPerSec: ({ stakingToken }: {
        stakingToken: Addr;
    }) => Promise<RewardsPerSecResponse>;
    rewardInfo: ({ stakerAddr, stakingToken }: {
        stakerAddr: Addr;
        stakingToken?: Addr;
    }) => Promise<RewardInfoResponse>;
    rewardInfos: ({ limit, order, stakingToken, startAfter }: {
        limit?: number;
        order?: number;
        stakingToken: Addr;
        startAfter?: Addr;
    }) => Promise<ArrayOfRewardInfoResponse>;
    getPoolsInformation: () => Promise<ArrayOfQueryPoolInfoResponse>;
    queryOldStore: ({ storeType }: {
        storeType: OldStoreType;
    }) => Promise<Binary>;
}
export interface OraiswapStakingInterface extends OraiswapStakingReadOnlyInterface {
    contractAddress: string;
    sender: string;
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ migrateStoreStatus, owner, rewarder }: {
        migrateStoreStatus?: boolean;
        owner?: Addr;
        rewarder?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    registerAsset: ({ stakingToken }: {
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    deprecateStakingToken: ({ newStakingToken, stakingToken }: {
        newStakingToken: Addr;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateRewardsPerSec: ({ assets, stakingToken }: {
        assets: Asset[];
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    depositReward: ({ rewards }: {
        rewards: RewardMsg[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unbond: ({ amount, stakingToken }: {
        amount: Uint128;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdraw: ({ stakingToken }: {
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawOthers: ({ stakerAddrs, stakingToken }: {
        stakerAddrs: Addr[];
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    autoStake: ({ assets, slippageTolerance }: {
        assets: Asset[];
        slippageTolerance?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    autoStakeHook: ({ prevStakingTokenAmount, stakerAddr, stakingToken }: {
        prevStakingTokenAmount: Uint128;
        stakerAddr: Addr;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
export declare class OraiswapStakingClient extends OraiswapStakingQueryClient implements OraiswapStakingInterface {
    client: SigningCosmWasmClient;
    sender: string;
    contractAddress: string;
    constructor(client: SigningCosmWasmClient, sender: string, contractAddress: string);
    receive: ({ amount, msg, sender }: {
        amount: Uint128;
        msg: Binary;
        sender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateConfig: ({ migrateStoreStatus, owner, rewarder }: {
        migrateStoreStatus?: boolean;
        owner?: Addr;
        rewarder?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    registerAsset: ({ stakingToken }: {
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    deprecateStakingToken: ({ newStakingToken, stakingToken }: {
        newStakingToken: Addr;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateRewardsPerSec: ({ assets, stakingToken }: {
        assets: Asset[];
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    depositReward: ({ rewards }: {
        rewards: RewardMsg[];
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    unbond: ({ amount, stakingToken }: {
        amount: Uint128;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdraw: ({ stakingToken }: {
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    withdrawOthers: ({ stakerAddrs, stakingToken }: {
        stakerAddrs: Addr[];
        stakingToken?: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    autoStake: ({ assets, slippageTolerance }: {
        assets: Asset[];
        slippageTolerance?: Decimal;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    autoStakeHook: ({ prevStakingTokenAmount, stakerAddr, stakingToken }: {
        prevStakingTokenAmount: Uint128;
        stakerAddr: Addr;
        stakingToken: Addr;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
