"use strict";
/**
* This file was automatically generated by @oraichain/ts-codegen@0.35.9.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run the @oraichain/ts-codegen generate command to regenerate this file.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.OraiswapStakingClient = exports.OraiswapStakingQueryClient = void 0;
class OraiswapStakingQueryClient {
    constructor(client, contractAddress) {
        this.config = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                config: {}
            });
        };
        this.poolInfo = async ({ stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                pool_info: {
                    staking_token: stakingToken
                }
            });
        };
        this.rewardsPerSec = async ({ stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                rewards_per_sec: {
                    staking_token: stakingToken
                }
            });
        };
        this.rewardInfo = async ({ stakerAddr, stakingToken }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                reward_info: {
                    staker_addr: stakerAddr,
                    staking_token: stakingToken
                }
            });
        };
        this.rewardInfos = async ({ limit, order, stakingToken, startAfter }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                reward_infos: {
                    limit,
                    order,
                    staking_token: stakingToken,
                    start_after: startAfter
                }
            });
        };
        this.getPoolsInformation = async () => {
            return this.client.queryContractSmart(this.contractAddress, {
                get_pools_information: {}
            });
        };
        this.queryOldStore = async ({ storeType }) => {
            return this.client.queryContractSmart(this.contractAddress, {
                query_old_store: {
                    store_type: storeType
                }
            });
        };
        this.client = client;
        this.contractAddress = contractAddress;
        this.config = this.config.bind(this);
        this.poolInfo = this.poolInfo.bind(this);
        this.rewardsPerSec = this.rewardsPerSec.bind(this);
        this.rewardInfo = this.rewardInfo.bind(this);
        this.rewardInfos = this.rewardInfos.bind(this);
        this.getPoolsInformation = this.getPoolsInformation.bind(this);
        this.queryOldStore = this.queryOldStore.bind(this);
    }
}
exports.OraiswapStakingQueryClient = OraiswapStakingQueryClient;
class OraiswapStakingClient extends OraiswapStakingQueryClient {
    constructor(client, sender, contractAddress) {
        super(client, contractAddress);
        this.receive = async ({ amount, msg, sender }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                receive: {
                    amount,
                    msg,
                    sender
                }
            }, _fee, _memo, _funds);
        };
        this.updateConfig = async ({ migrateStoreStatus, owner, rewarder }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_config: {
                    migrate_store_status: migrateStoreStatus,
                    owner,
                    rewarder
                }
            }, _fee, _memo, _funds);
        };
        this.registerAsset = async ({ stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                register_asset: {
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.deprecateStakingToken = async ({ newStakingToken, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                deprecate_staking_token: {
                    new_staking_token: newStakingToken,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.updateRewardsPerSec = async ({ assets, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                update_rewards_per_sec: {
                    assets,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.depositReward = async ({ rewards }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                deposit_reward: {
                    rewards
                }
            }, _fee, _memo, _funds);
        };
        this.unbond = async ({ amount, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                unbond: {
                    amount,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.withdraw = async ({ stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                withdraw: {
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.withdrawOthers = async ({ stakerAddrs, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                withdraw_others: {
                    staker_addrs: stakerAddrs,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.autoStake = async ({ assets, slippageTolerance }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                auto_stake: {
                    assets,
                    slippage_tolerance: slippageTolerance
                }
            }, _fee, _memo, _funds);
        };
        this.autoStakeHook = async ({ prevStakingTokenAmount, stakerAddr, stakingToken }, _fee = "auto", _memo, _funds) => {
            return await this.client.execute(this.sender, this.contractAddress, {
                auto_stake_hook: {
                    prev_staking_token_amount: prevStakingTokenAmount,
                    staker_addr: stakerAddr,
                    staking_token: stakingToken
                }
            }, _fee, _memo, _funds);
        };
        this.client = client;
        this.sender = sender;
        this.contractAddress = contractAddress;
        this.receive = this.receive.bind(this);
        this.updateConfig = this.updateConfig.bind(this);
        this.registerAsset = this.registerAsset.bind(this);
        this.deprecateStakingToken = this.deprecateStakingToken.bind(this);
        this.updateRewardsPerSec = this.updateRewardsPerSec.bind(this);
        this.depositReward = this.depositReward.bind(this);
        this.unbond = this.unbond.bind(this);
        this.withdraw = this.withdraw.bind(this);
        this.withdrawOthers = this.withdrawOthers.bind(this);
        this.autoStake = this.autoStake.bind(this);
        this.autoStakeHook = this.autoStakeHook.bind(this);
    }
}
exports.OraiswapStakingClient = OraiswapStakingClient;
//# sourceMappingURL=OraiswapStaking.client.js.map