/**
* This file was automatically generated by @oraichain/ts-codegen@0.35.9.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run the @oraichain/ts-codegen generate command to regenerate this file.
*/
import { CosmWasmClient, SigningCosmWasmClient, ExecuteResult } from "@cosmjs/cosmwasm-stargate";
import { Coin, StdFee } from "@cosmjs/amino";
import { Uint128, Logo, Binary } from "./types";
import { MinterResponse, Expiration, AllAccountsResponse, AllAllowancesResponse, AllSpenderAllowancesResponse, AllowanceResponse, BalanceResponse, DownloadLogoResponse, MarketingInfoResponse, TokenInfoResponse } from "./OraiswapToken.types";
export interface OraiswapTokenReadOnlyInterface {
    contractAddress: string;
    balance: ({ address }: {
        address: string;
    }) => Promise<BalanceResponse>;
    tokenInfo: () => Promise<TokenInfoResponse>;
    minter: () => Promise<MinterResponse>;
    allowance: ({ owner, spender }: {
        owner: string;
        spender: string;
    }) => Promise<AllowanceResponse>;
    allAllowances: ({ limit, owner, startAfter }: {
        limit?: number;
        owner: string;
        startAfter?: string;
    }) => Promise<AllAllowancesResponse>;
    allSpenderAllowances: ({ limit, spender, startAfter }: {
        limit?: number;
        spender: string;
        startAfter?: string;
    }) => Promise<AllSpenderAllowancesResponse>;
    allAccounts: ({ limit, startAfter }: {
        limit?: number;
        startAfter?: string;
    }) => Promise<AllAccountsResponse>;
    marketingInfo: () => Promise<MarketingInfoResponse>;
    downloadLogo: () => Promise<DownloadLogoResponse>;
}
export declare class OraiswapTokenQueryClient implements OraiswapTokenReadOnlyInterface {
    client: CosmWasmClient;
    contractAddress: string;
    constructor(client: CosmWasmClient, contractAddress: string);
    balance: ({ address }: {
        address: string;
    }) => Promise<BalanceResponse>;
    tokenInfo: () => Promise<TokenInfoResponse>;
    minter: () => Promise<MinterResponse>;
    allowance: ({ owner, spender }: {
        owner: string;
        spender: string;
    }) => Promise<AllowanceResponse>;
    allAllowances: ({ limit, owner, startAfter }: {
        limit?: number;
        owner: string;
        startAfter?: string;
    }) => Promise<AllAllowancesResponse>;
    allSpenderAllowances: ({ limit, spender, startAfter }: {
        limit?: number;
        spender: string;
        startAfter?: string;
    }) => Promise<AllSpenderAllowancesResponse>;
    allAccounts: ({ limit, startAfter }: {
        limit?: number;
        startAfter?: string;
    }) => Promise<AllAccountsResponse>;
    marketingInfo: () => Promise<MarketingInfoResponse>;
    downloadLogo: () => Promise<DownloadLogoResponse>;
}
export interface OraiswapTokenInterface extends OraiswapTokenReadOnlyInterface {
    contractAddress: string;
    sender: string;
    transfer: ({ amount, recipient }: {
        amount: Uint128;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    burn: ({ amount }: {
        amount: Uint128;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    send: ({ amount, contract, msg }: {
        amount: Uint128;
        contract: string;
        msg: Binary;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    increaseAllowance: ({ amount, expires, spender }: {
        amount: Uint128;
        expires?: Expiration;
        spender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    decreaseAllowance: ({ amount, expires, spender }: {
        amount: Uint128;
        expires?: Expiration;
        spender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    transferFrom: ({ amount, owner, recipient }: {
        amount: Uint128;
        owner: string;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    sendFrom: ({ amount, contract, msg, owner }: {
        amount: Uint128;
        contract: string;
        msg: Binary;
        owner: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    burnFrom: ({ amount, owner }: {
        amount: Uint128;
        owner: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    mint: ({ amount, recipient }: {
        amount: Uint128;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateMinter: ({ newMinter }: {
        newMinter?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateMarketing: ({ description, marketing, project }: {
        description?: string;
        marketing?: string;
        project?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    uploadLogo: (logo: Logo, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
export declare class OraiswapTokenClient extends OraiswapTokenQueryClient implements OraiswapTokenInterface {
    client: SigningCosmWasmClient;
    sender: string;
    contractAddress: string;
    constructor(client: SigningCosmWasmClient, sender: string, contractAddress: string);
    transfer: ({ amount, recipient }: {
        amount: Uint128;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    burn: ({ amount }: {
        amount: Uint128;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    send: ({ amount, contract, msg }: {
        amount: Uint128;
        contract: string;
        msg: Binary;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    increaseAllowance: ({ amount, expires, spender }: {
        amount: Uint128;
        expires?: Expiration;
        spender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    decreaseAllowance: ({ amount, expires, spender }: {
        amount: Uint128;
        expires?: Expiration;
        spender: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    transferFrom: ({ amount, owner, recipient }: {
        amount: Uint128;
        owner: string;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    sendFrom: ({ amount, contract, msg, owner }: {
        amount: Uint128;
        contract: string;
        msg: Binary;
        owner: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    burnFrom: ({ amount, owner }: {
        amount: Uint128;
        owner: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    mint: ({ amount, recipient }: {
        amount: Uint128;
        recipient: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateMinter: ({ newMinter }: {
        newMinter?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    updateMarketing: ({ description, marketing, project }: {
        description?: string;
        marketing?: string;
        project?: string;
    }, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
    uploadLogo: (logo: Logo, _fee?: number | StdFee | "auto", _memo?: string, _funds?: Coin[]) => Promise<ExecuteResult>;
}
